Index: /other-projects/maori-lang-detection/mongodb-data/5b_count_containsMRI_groupedByNZorOverseasNoFilter.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/5b_count_containsMRI_groupedByNZorOverseasNoFilter.json	(revision 33894)
+++ /other-projects/maori-lang-detection/mongodb-data/5b_count_containsMRI_groupedByNZorOverseasNoFilter.json	(revision 33894)
@@ -0,0 +1,228 @@
+/**
+Count by Country Code of sites with numPagesInMRI > 0
+without skipping any overseas sites with mi in URL path.
+
+
+Combination of 
+OVERSEAS
+db.Websites.aggregate([
+    {
+        $match: {
+            $and: [
+                {geoLocationCountryCode: {$ne: "NZ"}},
+                {domain: {$not: /\.nz/}},
+                {numPagesContainingMRI: {$gt: 0}}
+            ]
+        }
+    },
+    { $unwind: "$geoLocationCountryCode" },
+    {
+        $group: {
+            _id: {$toLower: '$geoLocationCountryCode'},
+            count: { $sum: 1 }           
+        }
+    },
+    { $sort : { count : -1} }
+]);
+
+db.Websites.aggregate([
+    {
+        $match: {
+            $and: [
+                {numPagesContainingMRI: {$gt: 0}},
+                {$or: [{geoLocationCountryCode:"NZ"},{domain: /\.nz/}]}
+            ]
+        }
+    },
+    { $unwind: "$geoLocationCountryCode" },
+    {
+        $group: {
+            _id: "nz",
+            count: { $sum: 1 }
+        }
+    },
+    { $sort : { count : -1} }
+]);
+
+*/
+
+
+/* 2 */
+{
+    "_id" : "us",
+    "count" : 422.0
+}
+
+/* 1 */
+{
+    "_id" : "nz",
+    "count" : 176.0
+}
+
+/* 2 */
+{
+    "_id" : "cn",
+    "count" : 114.0
+}
+
+/* 3 */
+{
+    "_id" : "fr",
+    "count" : 35.0
+}
+
+/* 4 */
+{
+    "_id" : "de",
+    "count" : 27.0
+}
+
+/* 5 */
+{
+    "_id" : "nl",
+    "count" : 22.0
+}
+
+/* 6 */
+{
+    "_id" : "ca",
+    "count" : 12.0
+}
+
+/* 7 */
+{
+    "_id" : "dk",
+    "count" : 8.0
+}
+
+/* 8 */
+{
+    "_id" : "gb",
+    "count" : 6.0
+}
+
+/* 9 */
+{
+    "_id" : "au",
+    "count" : 5.0
+}
+
+/* 10 */
+{
+    "_id" : "es",
+    "count" : 5.0
+}
+
+/* 11 */
+{
+    "_id" : "cz",
+    "count" : 4.0
+}
+
+/* 12 */
+{
+    "_id" : "at",
+    "count" : 3.0
+}
+
+/* 13 */
+{
+    "_id" : "it",
+    "count" : 3.0
+}
+
+/* 14 */
+{
+    "_id" : "unknown",
+    "count" : 3.0
+}
+
+/* 15 */
+{
+    "_id" : "hk",
+    "count" : 2.0
+}
+
+/* 16 */
+{
+    "_id" : "ie",
+    "count" : 2.0
+}
+
+/* 17 */
+{
+    "_id" : "jp",
+    "count" : 2.0
+}
+
+/* 18 */
+{
+    "_id" : "ch",
+    "count" : 2.0
+}
+
+/* 19 */
+{
+    "_id" : "ua",
+    "count" : 2.0
+}
+
+/* 20 */
+{
+    "_id" : "ru",
+    "count" : 2.0
+}
+
+/* 21 */
+{
+    "_id" : "il",
+    "count" : 2.0
+}
+
+/* 22 */
+{
+    "_id" : "ro",
+    "count" : 2.0
+}
+
+/* 23 */
+{
+    "_id" : "sg",
+    "count" : 1.0
+}
+
+/* 24 */
+{
+    "_id" : "eu",
+    "count" : 1.0
+}
+
+/* 25 */
+{
+    "_id" : "ir",
+    "count" : 1.0
+}
+
+/* 26 */
+{
+    "_id" : "bg",
+    "count" : 1.0
+}
+
+/* 27 */
+{
+    "_id" : "fi",
+    "count" : 1.0
+}
+
+/* 28 */
+{
+    "_id" : "tr",
+    "count" : 1.0
+}
+
+/* 29 */
+{
+    "_id" : "mx",
+    "count" : 1.0
+}
Index: /other-projects/maori-lang-detection/mongodb-data/5b_geojson-features_containsMRI_groupedByNZorOverseasNoFilter.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/5b_geojson-features_containsMRI_groupedByNZorOverseasNoFilter.json	(revision 33894)
+++ /other-projects/maori-lang-detection/mongodb-data/5b_geojson-features_containsMRI_groupedByNZorOverseasNoFilter.json	(revision 33894)
@@ -0,0 +1,1 @@
+{"type":"FeatureCollection","features":[{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-111.712891,37.09024],[-111.712891,89.84024],[-79.712891,89.84024],[-79.712891,37.09024],[-111.712891,37.09024]]]},"properties":{"code":"US","count":422,"region":"United States"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[170.885971,-40.900557],[170.885971,47.099443],[178.885971,47.099443],[178.885971,-40.900557],[170.885971,-40.900557]]]},"properties":{"code":"NZ","count":176,"region":"New Zealand"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[96.195397,35.86166],[96.195397,64.36166],[112.195397,64.36166],[112.195397,35.86166],[96.195397,35.86166]]]},"properties":{"code":"CN","count":114,"region":"China"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[0.21374899999999997,46.227638],[0.21374899999999997,81.227638],[4.213749,81.227638],[4.213749,46.227638],[0.21374899999999997,46.227638]]]},"properties":{"code":"FR","count":35,"region":"France"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[8.451526,51.165691],[8.451526,78.16569100000001],[12.451526,78.16569100000001],[12.451526,51.165691],[8.451526,51.165691]]]},"properties":{"code":"DE","count":27,"region":"Germany"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[3.2912660000000002,52.132633],[3.2912660000000002,74.132633],[7.291266,74.132633],[7.291266,52.132633],[3.2912660000000002,52.132633]]]},"properties":{"code":"NL","count":22,"region":"Netherlands"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-108.346771,56.130366],[-108.346771,68.13036600000001],[-104.346771,68.13036600000001],[-104.346771,56.130366],[-108.346771,56.130366]]]},"properties":{"code":"CA","count":12,"region":"Canada"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[7.501785,56.26392],[7.501785,64.26392],[11.501785,64.26392],[11.501785,56.26392],[7.501785,56.26392]]]},"properties":{"code":"DK","count":8,"region":"Denmark"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-5.435973000000001,55.378051],[-5.435973000000001,61.378051],[-1.4359730000000002,61.378051],[-1.4359730000000002,55.378051],[-5.435973000000001,55.378051]]]},"properties":{"code":"GB","count":6,"region":"United Kingdom"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[131.775136,-25.274398],[131.775136,-20.274398],[135.775136,-20.274398],[135.775136,-25.274398],[131.775136,-25.274398]]]},"properties":{"code":"AU","count":5,"region":"Australia"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-5.74922,40.463667],[-5.74922,45.463667],[-1.7492200000000002,45.463667],[-1.7492200000000002,40.463667],[-5.74922,40.463667]]]},"properties":{"code":"ES","count":5,"region":"Spain"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[13.472962,49.817492],[13.472962,53.817492],[17.472962000000003,53.817492],[17.472962000000003,49.817492],[13.472962,49.817492]]]},"properties":{"code":"CZ","count":4,"region":"Czech Republic"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[12.550072,47.516231],[12.550072,50.516231],[16.550072,50.516231],[16.550072,47.516231],[12.550072,47.516231]]]},"properties":{"code":"AT","count":3,"region":"Austria"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[10.56738,41.87194],[10.56738,44.87194],[14.56738,44.87194],[14.56738,41.87194],[10.56738,41.87194]]]},"properties":{"code":"IT","count":3,"region":"Italy"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[55.0,-70.0],[55.0,-67.0],[59.0,-67.0],[59.0,-70.0],[55.0,-70.0]]]},"properties":{"code":"UNKNOWN","count":3,"region":"UNKNOWN"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[112.109497,22.396428],[112.109497,24.396428],[116.109497,24.396428],[116.109497,22.396428],[112.109497,22.396428]]]},"properties":{"code":"HK","count":2,"region":"Hong Kong"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-10.24389,53.41291],[-10.24389,55.41291],[-6.24389,55.41291],[-6.24389,53.41291],[-10.24389,53.41291]]]},"properties":{"code":"IE","count":2,"region":"Ireland"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[136.252924,36.204824],[136.252924,38.204824],[140.252924,38.204824],[140.252924,36.204824],[136.252924,36.204824]]]},"properties":{"code":"JP","count":2,"region":"Japan"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[6.227512000000001,46.818188],[6.227512000000001,48.818188],[10.227512,48.818188],[10.227512,46.818188],[6.227512000000001,46.818188]]]},"properties":{"code":"CH","count":2,"region":"Switzerland"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[29.16558,48.379433],[29.16558,50.379433],[33.16558,50.379433],[33.16558,48.379433],[29.16558,48.379433]]]},"properties":{"code":"UA","count":2,"region":"Ukraine"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[103.318756,61.52401],[103.318756,63.52401],[107.318756,63.52401],[107.318756,61.52401],[103.318756,61.52401]]]},"properties":{"code":"RU","count":2,"region":"Russia"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[32.851612,31.046051],[32.851612,33.046051],[36.851612,33.046051],[36.851612,31.046051],[32.851612,31.046051]]]},"properties":{"code":"IL","count":2,"region":"Israel"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[22.96676,45.943161],[22.96676,47.943161],[26.96676,47.943161],[26.96676,45.943161],[22.96676,45.943161]]]},"properties":{"code":"RO","count":2,"region":"Romania"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[101.819836,1.352083],[101.819836,2.352083],[105.819836,2.352083],[105.819836,1.352083],[101.819836,1.352083]]]},"properties":{"code":"SG","count":1,"region":"Singapore"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-22.0,50.0],[-22.0,51.0],[-18.0,51.0],[-18.0,50.0],[-22.0,50.0]]]},"properties":{"code":"EU","count":1,"region":"Europe"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[51.688046,32.427908],[51.688046,33.427908],[55.688046,33.427908],[55.688046,32.427908],[51.688046,32.427908]]]},"properties":{"code":"IR","count":1,"region":"Iran"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[23.48583,42.733883],[23.48583,43.733883],[27.48583,43.733883],[27.48583,42.733883],[23.48583,42.733883]]]},"properties":{"code":"BG","count":1,"region":"Bulgaria"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[23.748151,61.92411],[23.748151,62.92411],[27.748151,62.92411],[27.748151,61.92411],[23.748151,61.92411]]]},"properties":{"code":"FI","count":1,"region":"Finland"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[33.243322,38.963745],[33.243322,39.963745],[37.243322,39.963745],[37.243322,38.963745],[33.243322,38.963745]]]},"properties":{"code":"TR","count":1,"region":"Turkey"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-104.552784,23.634501],[-104.552784,24.634501],[-100.552784,24.634501],[-100.552784,23.634501],[-104.552784,23.634501]]]},"properties":{"code":"MX","count":1,"region":"Mexico"}}]}
Index: /other-projects/maori-lang-detection/mongodb-data/5b_multipoint_containsMRI_groupedByNZorOverseasNoFilter.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/5b_multipoint_containsMRI_groupedByNZorOverseasNoFilter.json	(revision 33894)
+++ /other-projects/maori-lang-detection/mongodb-data/5b_multipoint_containsMRI_groupedByNZorOverseasNoFilter.json	(revision 33894)
@@ -0,0 +1,33 @@
+{"type":"MultiPoint","coordinates":
+[
+	[-95.712891,37.09024],
+	[174.885971,-40.900557],
+	[104.195397,35.86166],
+	[2.213749,46.227638],
+	[10.451526,51.165691],
+	[5.291266,52.132633],
+	[-106.346771,56.130366],
+	[9.501785,56.26392],
+	[-3.435973,55.378051],
+	[133.775136,-25.274398],
+	[-3.74922,40.463667],
+	[15.472962,49.817492],
+	[14.550072,47.516231],
+	[12.56738,41.87194],
+	[57.0,-70.0],
+	[114.109497,22.396428],
+	[-8.24389,53.41291],
+	[138.252924,36.204824],
+	[8.227512,46.818188],
+	[31.16558,48.379433],
+	[105.318756,61.52401],
+	[34.851612,31.046051],
+	[24.96676,45.943161],
+	[103.819836,1.352083],
+	[-20.0,50.0],
+	[53.688046,32.427908],
+	[25.48583,42.733883],
+	[25.748151,61.92411],
+	[35.243322,38.963745],
+	[-102.552784,23.634501]
+]}
Index: her-projects/maori-lang-detection/mongodb-data/6counts_nonProductSites1_manualShortlist.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/6counts_nonProductSites1_manualShortlist.json	(revision 33893)
+++ 	(revision )
@@ -1,48 +1,0 @@
-/*
-Manually inspected non-NZ websites in tentativeNonProductSites1.json
-and made a list of sites with genuine Maori language content for each country.
-
-Includes 3 more sites from US with mi in URL path that do not appear to be autotranslated.
-See file 7miInURLPath_exclNZ_byCountryCode.json
-*/
-{
-    "_id" : "nz",
-    "count" : 176.0
-}
-{
-    "_id" : "us",
-    "count" : 29.0
-}
-{
-    "_id" : "au",
-    "count" : 2.0
-}
-{
-    "_id" : "de",
-    "count" : 2.0
-}
-{
-    "_id" : "dk",
-    "count" : 2.0
-}
-{
-    "_id" : "bg",
-    "count" : 1.0
-}
-{
-    "_id" : "cz",
-    "count" : 1.0
-}
-{
-    "_id" : "es",
-    "count" : 1.0
-}
-{
-    "_id" : "fr",
-    "count" : 1.0
-}
-{
-    "_id" : "ie",
-    "count" : 1.0
-}
-
Index: /other-projects/maori-lang-detection/mongodb-data/6counts_sitesWithPagesContainingMRI_manualShortlist.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/6counts_sitesWithPagesContainingMRI_manualShortlist.json	(revision 33894)
+++ /other-projects/maori-lang-detection/mongodb-data/6counts_sitesWithPagesContainingMRI_manualShortlist.json	(revision 33894)
@@ -0,0 +1,48 @@
+/*
+Manually inspected non-NZ websites in tentativeNonProductSites1.json
+and made a list of sites with genuine Maori language content for each country.
+
+Includes 3 more sites from US with mi in URL path that do not appear to be autotranslated.
+See file 7miInURLPath_exclNZ_byCountryCode.json
+*/
+{
+    "_id" : "nz",
+    "count" : 126.0
+}
+{
+    "_id" : "us",
+    "count" : 29.0
+}
+{
+    "_id" : "au",
+    "count" : 2.0
+}
+{
+    "_id" : "de",
+    "count" : 2.0
+}
+{
+    "_id" : "dk",
+    "count" : 2.0
+}
+{
+    "_id" : "bg",
+    "count" : 1.0
+}
+{
+    "_id" : "cz",
+    "count" : 1.0
+}
+{
+    "_id" : "es",
+    "count" : 1.0
+}
+{
+    "_id" : "fr",
+    "count" : 1.0
+}
+{
+    "_id" : "ie",
+    "count" : 1.0
+}
+
Index: her-projects/maori-lang-detection/mongodb-data/6geojson-features_nonProductSites1_manualShortlist.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/6geojson-features_nonProductSites1_manualShortlist.json	(revision 33893)
+++ 	(revision )
@@ -1,1 +1,0 @@
-{"type":"FeatureCollection","features":[{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[170.885971,-40.900557],[170.885971,47.099443],[178.885971,47.099443],[178.885971,-40.900557],[170.885971,-40.900557]]]},"properties":{"code":"NZ","count":176,"region":"New Zealand"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-97.712891,37.09024],[-97.712891,66.09024],[-93.712891,66.09024],[-93.712891,37.09024],[-97.712891,37.09024]]]},"properties":{"code":"US","count":29,"region":"United States"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[131.775136,-25.274398],[131.775136,-23.274398],[135.775136,-23.274398],[135.775136,-25.274398],[131.775136,-25.274398]]]},"properties":{"code":"AU","count":2,"region":"Australia"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[8.451526,51.165691],[8.451526,53.165691],[12.451526,53.165691],[12.451526,51.165691],[8.451526,51.165691]]]},"properties":{"code":"DE","count":2,"region":"Germany"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[7.501785,56.26392],[7.501785,58.26392],[11.501785,58.26392],[11.501785,56.26392],[7.501785,56.26392]]]},"properties":{"code":"DK","count":2,"region":"Denmark"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[23.48583,42.733883],[23.48583,43.733883],[27.48583,43.733883],[27.48583,42.733883],[23.48583,42.733883]]]},"properties":{"code":"BG","count":1,"region":"Bulgaria"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[13.472962,49.817492],[13.472962,50.817492],[17.472962000000003,50.817492],[17.472962000000003,49.817492],[13.472962,49.817492]]]},"properties":{"code":"CZ","count":1,"region":"Czech Republic"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-5.74922,40.463667],[-5.74922,41.463667],[-1.7492200000000002,41.463667],[-1.7492200000000002,40.463667],[-5.74922,40.463667]]]},"properties":{"code":"ES","count":1,"region":"Spain"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[0.21374899999999997,46.227638],[0.21374899999999997,47.227638],[4.213749,47.227638],[4.213749,46.227638],[0.21374899999999997,46.227638]]]},"properties":{"code":"FR","count":1,"region":"France"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-10.24389,53.41291],[-10.24389,54.41291],[-6.24389,54.41291],[-6.24389,53.41291],[-10.24389,53.41291]]]},"properties":{"code":"IE","count":1,"region":"Ireland"}}]}
Index: /other-projects/maori-lang-detection/mongodb-data/6geojson-features_sitesWithPagesContainingMRI_manualShortlist.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/6geojson-features_sitesWithPagesContainingMRI_manualShortlist.json	(revision 33894)
+++ /other-projects/maori-lang-detection/mongodb-data/6geojson-features_sitesWithPagesContainingMRI_manualShortlist.json	(revision 33894)
@@ -0,0 +1,1 @@
+{"type":"FeatureCollection","features":[{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[172.885971,-40.900557],[172.885971,85.09944300000001],[176.885971,85.09944300000001],[176.885971,-40.900557],[172.885971,-40.900557]]]},"properties":{"code":"NZ","count":126,"region":"New Zealand"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-97.712891,37.09024],[-97.712891,66.09024],[-93.712891,66.09024],[-93.712891,37.09024],[-97.712891,37.09024]]]},"properties":{"code":"US","count":29,"region":"United States"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[131.775136,-25.274398],[131.775136,-23.274398],[135.775136,-23.274398],[135.775136,-25.274398],[131.775136,-25.274398]]]},"properties":{"code":"AU","count":2,"region":"Australia"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[8.451526,51.165691],[8.451526,53.165691],[12.451526,53.165691],[12.451526,51.165691],[8.451526,51.165691]]]},"properties":{"code":"DE","count":2,"region":"Germany"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[7.501785,56.26392],[7.501785,58.26392],[11.501785,58.26392],[11.501785,56.26392],[7.501785,56.26392]]]},"properties":{"code":"DK","count":2,"region":"Denmark"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[23.48583,42.733883],[23.48583,43.733883],[27.48583,43.733883],[27.48583,42.733883],[23.48583,42.733883]]]},"properties":{"code":"BG","count":1,"region":"Bulgaria"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[13.472962,49.817492],[13.472962,50.817492],[17.472962000000003,50.817492],[17.472962000000003,49.817492],[13.472962,49.817492]]]},"properties":{"code":"CZ","count":1,"region":"Czech Republic"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-5.74922,40.463667],[-5.74922,41.463667],[-1.7492200000000002,41.463667],[-1.7492200000000002,40.463667],[-5.74922,40.463667]]]},"properties":{"code":"ES","count":1,"region":"Spain"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[0.21374899999999997,46.227638],[0.21374899999999997,47.227638],[4.213749,47.227638],[4.213749,46.227638],[0.21374899999999997,46.227638]]]},"properties":{"code":"FR","count":1,"region":"France"}},{"type":"Feature","geometry":{"type":"Polygon","coordinates":[[[-10.24389,53.41291],[-10.24389,54.41291],[-6.24389,54.41291],[-6.24389,53.41291],[-10.24389,53.41291]]]},"properties":{"code":"IE","count":1,"region":"Ireland"}}]}
Index: her-projects/maori-lang-detection/mongodb-data/6multipoint_nonProductSites1_manualShortlist.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/6multipoint_nonProductSites1_manualShortlist.json	(revision 33893)
+++ 	(revision )
@@ -1,13 +1,0 @@
-{"type":"MultiPoint","coordinates":
-[
-	[174.885971,-40.900557],
-	[-95.712891,37.09024],
-	[133.775136,-25.274398],
-	[10.451526,51.165691],
-	[9.501785,56.26392],
-	[25.48583,42.733883],
-	[15.472962,49.817492],
-	[-3.74922,40.463667],
-	[2.213749,46.227638],
-	[-8.24389,53.41291]
-]}
Index: /other-projects/maori-lang-detection/mongodb-data/6multipoint_sitesWithPagesContainingMRI_manualShortlist.json
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/6multipoint_sitesWithPagesContainingMRI_manualShortlist.json	(revision 33894)
+++ /other-projects/maori-lang-detection/mongodb-data/6multipoint_sitesWithPagesContainingMRI_manualShortlist.json	(revision 33894)
@@ -0,0 +1,13 @@
+{"type":"MultiPoint","coordinates":
+[
+	[174.885971,-40.900557],
+	[-95.712891,37.09024],
+	[133.775136,-25.274398],
+	[10.451526,51.165691],
+	[9.501785,56.26392],
+	[25.48583,42.733883],
+	[15.472962,49.817492],
+	[-3.74922,40.463667],
+	[2.213749,46.227638],
+	[-8.24389,53.41291]
+]}
Index: /other-projects/maori-lang-detection/mongodb-data/tables.txt
===================================================================
--- /other-projects/maori-lang-detection/mongodb-data/tables.txt	(revision 33893)
+++ /other-projects/maori-lang-detection/mongodb-data/tables.txt	(revision 33894)
@@ -216,2 +216,59 @@
 ]);
 
+
+5b. Table 5b:
+Table of count of sites with numPagesCoMRI > 0
+
+Combine the following two:
+
+- OVERSEAS
+
+db.Websites.aggregate([
+    {
+        $match: {
+            $and: [
+                {geoLocationCountryCode: {$ne: "NZ"}},
+                {domain: {$not: /\.nz/}},
+                {numPagesContainingMRI: {$gt: 0}}
+            ]
+        }
+    },
+    { $unwind: "$geoLocationCountryCode" },
+    {
+        $group: {
+            _id: {$toLower: '$geoLocationCountryCode'},
+            count: { $sum: 1 },
+            /*domain: { $addToSet: '$domain' },*/
+            numPagesInMRICount: { $sum: '$numPagesInMRI' },
+            numPagesContainingMRICount: { $sum: '$numPagesContainingMRI' },
+            totalPagesAcrossMatchingSites: { $sum: '$totalPages'}
+        }
+    },
+    { $sort : { count : -1} }
+]);
+
+- NZ:
+
+db.Websites.aggregate([
+    {
+        $match: {
+            $and: [
+                {numPagesContainingMRI: {$gt: 0}},
+                {$or: [{geoLocationCountryCode:"NZ"},{domain: /\.nz/}]}
+            ]
+        }
+    },
+    { $unwind: "$geoLocationCountryCode" },
+    {
+        $group: {
+            _id: "nz",
+            count: { $sum: 1 },
+            /*domain: { $addToSet: '$domain' },*/
+            numPagesInMRICount: { $sum: '$numPagesInMRI' },
+            numPagesContainingMRICount: { $sum: '$numPagesContainingMRI' },
+            totalPagesAcrossMatchingSites: { $sum: '$totalPages'}
+        }
+    },
+    { $sort : { count : -1} }
+]);
+