Index: other-projects/maori-lang-detection/mongodb-data/5b_count_containsMRI_groupedByNZorOverseasNoFilter.json
===================================================================
--- other-projects/maori-lang-detection/mongodb-data/5b_count_containsMRI_groupedByNZorOverseasNoFilter.json	(revision 33894)
+++ 	(revision )
@@ -1,228 +1,0 @@
-/**
-Count by Country Code of sites with numPagesInMRI > 0
-without skipping any overseas sites with mi in URL path.
-
-
-Combination of 
-OVERSEAS
-db.Websites.aggregate([
-    {
-        $match: {
-            $and: [
-                {geoLocationCountryCode: {$ne: "NZ"}},
-                {domain: {$not: /\.nz/}},
-                {numPagesContainingMRI: {$gt: 0}}
-            ]
-        }
-    },
-    { $unwind: "$geoLocationCountryCode" },
-    {
-        $group: {
-            _id: {$toLower: '$geoLocationCountryCode'},
-            count: { $sum: 1 }           
-        }
-    },
-    { $sort : { count : -1} }
-]);
-
-db.Websites.aggregate([
-    {
-        $match: {
-            $and: [
-                {numPagesContainingMRI: {$gt: 0}},
-                {$or: [{geoLocationCountryCode:"NZ"},{domain: /\.nz/}]}
-            ]
-        }
-    },
-    { $unwind: "$geoLocationCountryCode" },
-    {
-        $group: {
-            _id: "nz",
-            count: { $sum: 1 }
-        }
-    },
-    { $sort : { count : -1} }
-]);
-
-*/
-
-
-/* 2 */
-{
-    "_id" : "us",
-    "count" : 422.0
-}
-
-/* 1 */
-{
-    "_id" : "nz",
-    "count" : 176.0
-}
-
-/* 2 */
-{
-    "_id" : "cn",
-    "count" : 114.0
-}
-
-/* 3 */
-{
-    "_id" : "fr",
-    "count" : 35.0
-}
-
-/* 4 */
-{
-    "_id" : "de",
-    "count" : 27.0
-}
-
-/* 5 */
-{
-    "_id" : "nl",
-    "count" : 22.0
-}
-
-/* 6 */
-{
-    "_id" : "ca",
-    "count" : 12.0
-}
-
-/* 7 */
-{
-    "_id" : "dk",
-    "count" : 8.0
-}
-
-/* 8 */
-{
-    "_id" : "gb",
-    "count" : 6.0
-}
-
-/* 9 */
-{
-    "_id" : "au",
-    "count" : 5.0
-}
-
-/* 10 */
-{
-    "_id" : "es",
-    "count" : 5.0
-}
-
-/* 11 */
-{
-    "_id" : "cz",
-    "count" : 4.0
-}
-
-/* 12 */
-{
-    "_id" : "at",
-    "count" : 3.0
-}
-
-/* 13 */
-{
-    "_id" : "it",
-    "count" : 3.0
-}
-
-/* 14 */
-{
-    "_id" : "unknown",
-    "count" : 3.0
-}
-
-/* 15 */
-{
-    "_id" : "hk",
-    "count" : 2.0
-}
-
-/* 16 */
-{
-    "_id" : "ie",
-    "count" : 2.0
-}
-
-/* 17 */
-{
-    "_id" : "jp",
-    "count" : 2.0
-}
-
-/* 18 */
-{
-    "_id" : "ch",
-    "count" : 2.0
-}
-
-/* 19 */
-{
-    "_id" : "ua",
-    "count" : 2.0
-}
-
-/* 20 */
-{
-    "_id" : "ru",
-    "count" : 2.0
-}
-
-/* 21 */
-{
-    "_id" : "il",
-    "count" : 2.0
-}
-
-/* 22 */
-{
-    "_id" : "ro",
-    "count" : 2.0
-}
-
-/* 23 */
-{
-    "_id" : "sg",
-    "count" : 1.0
-}
-
-/* 24 */
-{
-    "_id" : "eu",
-    "count" : 1.0
-}
-
-/* 25 */
-{
-    "_id" : "ir",
-    "count" : 1.0
-}
-
-/* 26 */
-{
-    "_id" : "bg",
-    "count" : 1.0
-}
-
-/* 27 */
-{
-    "_id" : "fi",
-    "count" : 1.0
-}
-
-/* 28 */
-{
-    "_id" : "tr",
-    "count" : 1.0
-}
-
-/* 29 */
-{
-    "_id" : "mx",
-    "count" : 1.0
-}
Index: other-projects/maori-lang-detection/mongodb-data/5b_counts_containsMRI_groupedByNZorOverseasNoFilter.json
===================================================================
--- other-projects/maori-lang-detection/mongodb-data/5b_counts_containsMRI_groupedByNZorOverseasNoFilter.json	(revision 33895)
+++ other-projects/maori-lang-detection/mongodb-data/5b_counts_containsMRI_groupedByNZorOverseasNoFilter.json	(revision 33895)
@@ -0,0 +1,228 @@
+/**
+Count by Country Code of sites with numPagesInMRI > 0
+without skipping any overseas sites with mi in URL path.
+
+
+Combination of 
+OVERSEAS
+db.Websites.aggregate([
+    {
+        $match: {
+            $and: [
+                {geoLocationCountryCode: {$ne: "NZ"}},
+                {domain: {$not: /\.nz/}},
+                {numPagesContainingMRI: {$gt: 0}}
+            ]
+        }
+    },
+    { $unwind: "$geoLocationCountryCode" },
+    {
+        $group: {
+            _id: {$toLower: '$geoLocationCountryCode'},
+            count: { $sum: 1 }           
+        }
+    },
+    { $sort : { count : -1} }
+]);
+
+db.Websites.aggregate([
+    {
+        $match: {
+            $and: [
+                {numPagesContainingMRI: {$gt: 0}},
+                {$or: [{geoLocationCountryCode:"NZ"},{domain: /\.nz/}]}
+            ]
+        }
+    },
+    { $unwind: "$geoLocationCountryCode" },
+    {
+        $group: {
+            _id: "nz",
+            count: { $sum: 1 }
+        }
+    },
+    { $sort : { count : -1} }
+]);
+
+*/
+
+
+/* 2 */
+{
+    "_id" : "us",
+    "count" : 422.0
+}
+
+/* 1 */
+{
+    "_id" : "nz",
+    "count" : 176.0
+}
+
+/* 2 */
+{
+    "_id" : "cn",
+    "count" : 114.0
+}
+
+/* 3 */
+{
+    "_id" : "fr",
+    "count" : 35.0
+}
+
+/* 4 */
+{
+    "_id" : "de",
+    "count" : 27.0
+}
+
+/* 5 */
+{
+    "_id" : "nl",
+    "count" : 22.0
+}
+
+/* 6 */
+{
+    "_id" : "ca",
+    "count" : 12.0
+}
+
+/* 7 */
+{
+    "_id" : "dk",
+    "count" : 8.0
+}
+
+/* 8 */
+{
+    "_id" : "gb",
+    "count" : 6.0
+}
+
+/* 9 */
+{
+    "_id" : "au",
+    "count" : 5.0
+}
+
+/* 10 */
+{
+    "_id" : "es",
+    "count" : 5.0
+}
+
+/* 11 */
+{
+    "_id" : "cz",
+    "count" : 4.0
+}
+
+/* 12 */
+{
+    "_id" : "at",
+    "count" : 3.0
+}
+
+/* 13 */
+{
+    "_id" : "it",
+    "count" : 3.0
+}
+
+/* 14 */
+{
+    "_id" : "unknown",
+    "count" : 3.0
+}
+
+/* 15 */
+{
+    "_id" : "hk",
+    "count" : 2.0
+}
+
+/* 16 */
+{
+    "_id" : "ie",
+    "count" : 2.0
+}
+
+/* 17 */
+{
+    "_id" : "jp",
+    "count" : 2.0
+}
+
+/* 18 */
+{
+    "_id" : "ch",
+    "count" : 2.0
+}
+
+/* 19 */
+{
+    "_id" : "ua",
+    "count" : 2.0
+}
+
+/* 20 */
+{
+    "_id" : "ru",
+    "count" : 2.0
+}
+
+/* 21 */
+{
+    "_id" : "il",
+    "count" : 2.0
+}
+
+/* 22 */
+{
+    "_id" : "ro",
+    "count" : 2.0
+}
+
+/* 23 */
+{
+    "_id" : "sg",
+    "count" : 1.0
+}
+
+/* 24 */
+{
+    "_id" : "eu",
+    "count" : 1.0
+}
+
+/* 25 */
+{
+    "_id" : "ir",
+    "count" : 1.0
+}
+
+/* 26 */
+{
+    "_id" : "bg",
+    "count" : 1.0
+}
+
+/* 27 */
+{
+    "_id" : "fi",
+    "count" : 1.0
+}
+
+/* 28 */
+{
+    "_id" : "tr",
+    "count" : 1.0
+}
+
+/* 29 */
+{
+    "_id" : "mx",
+    "count" : 1.0
+}